function varargout = userfun(varargin)
% USERFUN Application M-file for userfun.fig
%    FIG = USERFUN launch userfun GUI.
%    USERFUN('callback_name', ...) invoke the named callback.


% Last Modified by GUIDE v2.0 04-Sep-2002 11:20:31
global  system
if ~isfield(system.struct, 'filecontent')
    errordlg('The current system was created using an older version of Matcont. This system needs to be regenerated. Please go the edit-system screen and press OK without changing the system, this will recompute the system in the new format');
    varargout{1} = [];
    return
end
if nargin == 0  % LAUNCH GUI

	system.struct.forbiddentags = {'FP' , 'NS' , 'LP' , 'PD' , 'CP', 'CH' , 'R1' , 'R2' , 'R3','R4' , 'BP' };
	
	fig = openfig(mfilename,'reuse');
    system.old_struct = system.struct;
	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);
    load_listbox1(handles);
	
	
	% Wait for callbacks to run and window to be dismissed:
	uiwait(fig);

	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);      
	end
end

% --------------------------------------------------------------------
function adbutton_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.adbutton.

global system;
label = get(handles.label,'String');
name  = get(handles.name,'String');
if length(label)>2
    warndlg('A label exist of 2 characters')
    set(handles.label,'String',label(1:2));
elseif length(label)<2
    while length(label)<2
        label = sprintf('%s%c',label,char(32));
    end
    set(handles.label,'String',label(1:2));
end
if length(name)<1
    warndlg('You have to enter the name of the function');
    return;
end
if isfield(system.struct,'userfunction')%userfunctions already exists
    dim = size(system.struct.userfunction,2);
    namestr  = cellstr(char(system.struct.uf.UserfunctionsInfo.name));
    labelstr = cellstr(char(system.struct.uf.UserfunctionsInfo.label));
    system.struct.uf.UserfunctionsInfo(dim+1).label = label;
    system.struct.uf.UserfunctionsInfo(dim+1).name = name;
    system.struct.uf.UserfunctionsInfo(dim+1).state = 1;
    system.struct.userfunction{dim+1} = get(handles.edituserfunction,'String');
    i = find(strcmp(namestr,name));
    if i
        button = questdlg('Userfunction already exist! Do you want to continue? If you press yes to continue, you will overwrite the existing userfunction',...
            'Userfunction already exist','Yes','No','No');
        if strcmp(button,'No')
            system.struct.userfunction(dim+1) = [];
            system.struct.uf.UserfunctionsInfo(dim+1) = [];
            return;
        elseif strcmp(button,'Yes')
            system.struct.userfunction(dim+1)=[];
            system.struct.uf.UserfunctionsInfo(dim+1) = [];
            system.struct.uf.UserfunctionsInfo(i).label = label;
            system.struct.uf.UserfunctionsInfo(i).name = name;
            system.struct.userfunction{i} = get(handles.edituserfunction,'String');
        end
    end
    if find(strcmp(labelstr,label))
        warndlg('There is another userfunction using this label: please choose another label!');
        set(handles.label,'String','');
        system.struct.userfunction(dim+1) = [];
        system.struct.uf.UserfunctionsInfo(dim+1) = [];
    end
else
    system.struct.uf.UserfunctionsInfo=[];
    system.struct.userfunction{1}=get(handles.edituserfunction,'String');
    system.struct.uf.UserfunctionsInfo.label = label;
    system.struct.uf.UserfunctionsInfo.name  = name;
    system.struct.uf.UserfunctionsInfo.state = 1;
end
load_listbox1(handles);

  
% --------------------------------------------------------------------
function listbox1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.renamebutton.
global system
if isfield(system.struct,'userfunction')
    val=get(handles.listbox1,'Value');
    d=0;
    for k=1:size(system.struct.userfunction,2)
        if ~isempty(system.struct.userfunction{k})
            d=d+1;
            if d==val
                set(handles.name,'String',system.struct.uf.UserfunctionsInfo(k).name);
                name_Callback(handles,[],handles);
                set(handles.label,'String',system.struct.uf.UserfunctionsInfo(k).label);
                set(handles.edituserfunction,'String',system.struct.userfunction{k});
                break;
            end
        end
    end
else
    set(handles.name,'String','');
    name_Callback(handles,[],handles);
    set(handles.label,'String','');
    set(handles.edituserfunction,'String','');
end


% --------------------------------------------------------------------
function label_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.renamebutton.
global system
label=get(handles.label,'String');
if length(label)>2
    warndlg('A label exist of 2 characters')
    set(handles.label,'String',label(1:2));
elseif length(label)<2
    while length(label)<2
        label=sprintf('%s%c',label,char(32));
    end
    set(handles.label,'String',label(1:2));
end

if ismember(label , system.struct.forbiddentags );
    warndlg('Labels should be unique and differ from labels of standard special points.')
    set(handles.label,'String','');
end

% --------------------------------------------------------------------
function name_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.renamebutton.
global system
set(handles.adbutton,'Enable','on');
set(handles.updatebutton,'Enable','off');
name = get(handles.name,'String');
if isfield(system.struct,'userfunction')%userfunctions already exists
    if find(strcmp(cellstr(strvcat(system.struct.uf.UserfunctionsInfo.name)),name))
        set(handles.updatebutton,'Enable','on');
        set(handles.adbutton,'Enable','off');
    end
end


% --------------------------------------------------------------------
function deletebutton_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.deletebuttton.
global system
% set(handles.deletebutton,'Enable','off');

name  = get(handles.listbox1,'String');
val   = get(handles.listbox1,'Value');
label = get(handles.label,'String');
if isfield(system.struct,'userfunction')%userfunctions already exists
    dim = size(system.struct.userfunction,2);
    i = find(strcmp(cellstr(char(system.struct.uf.UserfunctionsInfo.name)),name{val}));
    if i
        button = questdlg('Do you want to continue? If you press yes to continue, you will delete the existing userfunction',...
                'Delete userfunction ','Yes','No','No');          
        if strcmp(button,'Yes')
            if isfield(system.struct,'poincare_eq') && ~isempty(system.struct.poincare_eq)
                funct=func2str(system.struct.poincare_eq);
                if strcmp(funct,name{val})
                    system.struct.poincare_eq=[];
                    system.struct.poincare_do=0;
                    system.struct=rmfield(system.struct,'poincare_eq');
                end
            end    
            system.struct.userfunction{i} = '';
            system.struct.uf.UserfunctionsInfo(i).state = 0;
        end
    end
end
load_listbox1(handles);

% --------------------------------------------------------------------
function updatebutton_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.updatebutton.
global system
nameu = get(handles.name,'String'); label = get(handles.label,'String');
if isfield(system.struct,'userfunction')%userfunctions already exists
    i = find(strcmp(cellstr(char(system.struct.uf.UserfunctionsInfo.name)),nameu));
    system.struct.uf.UserfunctionsInfo(i).label = label;
    system.struct.uf.UserfunctionsInfo(i).name = nameu;
    system.struct.uf.UserfunctionsInfo(i).state = 1;
    system.struct.userfunction{i}=get(handles.edituserfunction,'String');
end
load_listbox1(handles);

% --------------------------------------------------------------------
function cancelbutton_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.cancelbutton.
global system 
system.struct  = system.old_struct;


delete(handles.userfunfig);

%-----------------------------------------------------------------
function load_listbox1(handles)
global system
if isfield(system.struct,'userfunction') && ~isempty(char(system.struct.userfunction))
    str = [];d=0;
    for i=1:size(system.struct.userfunction,2)
        if ~isempty(system.struct.userfunction{i})
            d=d+1;
            str{d,1} = system.struct.uf.UserfunctionsInfo(i).name;
            val=i;
        end
    end
    set(handles.listbox1,'String',cellstr(str),'Value',d);
    set(handles.name,'String',system.struct.uf.UserfunctionsInfo(val).name);
    name_Callback(handles,[],handles);
    set(handles.label,'String',system.struct.uf.UserfunctionsInfo(val).label);
    set(handles.edituserfunction,'String',system.struct.userfunction{val});
else
    set(handles.listbox1,'String','');
    set(handles.name,'String','');
    name_Callback(handles,[],handles);
    set(handles.label,'String','');
    set(handles.edituserfunction,'String','res=');

end


% --------------------------------------------------------------------
function okbutton_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.okbutton.
global system 
name = get(handles.name,'String');
ad   = get(handles.adbutton,'Enable');
if ~isempty(name) && strcmp(ad,'on')
    adbutton_Callback(h,[],handles,[]);
end
updat = get(handles.updatebutton,'Enable');
if ~isempty(name) && strcmp (updat,'on')
    updatebutton_Callback(h,[],handles,[]);
end
if isfield(system.struct,'userfunction'),system.struct.uf.Userfunctions = 1;
else system.struct.uf.Userfunctions = 0;end
string_jac = '';string_jacp = '';string_hess = '';string_hessp = '';string_tensor3='';string_tensor4='';string_tensor5='';

dimp = size(system.struct.parameters,1);par='';pa='';
if ~isempty(dimp)
    par = cellstr((strcat(',',char(system.struct.parameters{:,1}))));
    par = strcat(par{:,1});
    pa  = par(2:end);
end
cor = '';
t = system.struct.time{1,1};
if (~isempty(system.struct.dim))
    cor = cellstr((strcat(',',char(system.struct.coordinates{:,1}))));
    cor = strcat(cor{:,1}); cor = cor(2:end);
end
if (~isempty(t))
    t=strcat(t,',');
else
    t='t,';
end
string_sys = cellstr(systems('replace_sys_input',system.struct.equations));
if strcmp(string_sys,'error')
    errordlg('The number of equations is not correct','Error');
    return
end
fwrite = strcat(system.struct.system,'.m');
fwrite = fullfile(system.path_sys,fwrite);
[fid_write,message] = fopen(fwrite,'w');
if fid_write==-1
    errordlg(message,'Error');
    return
end
fread = fullfile(system.path_sys,'standard.m');
[fid_read,message] = fopen(fread,'r');
if fid_read == -1
    errordlg(message,'Error');
    return
end


set(handles.userfunfig , 'Visible' , 'off');
drawnow;

string_handles={'out{1} = [];';
                'out{2} = @fun_eval;';
                'out{3} = [];';
                'out{4} = [];';
                'out{5} = [];';
                'out{6} = [];';
                'out{7} = [];';
                'out{8} = [];';
                'out{9} = [];';
                'return;';};
   
string_index = 3;
der_index = 1;
if sum(system.struct.der(2:end,der_index)) >= 1
    string_handles{string_index}=strrep(string_handles{string_index},'[]','@jacobian');
    string_handles{string_index+1}=strrep(string_handles{string_index+1},'[]','@jacobianp');
    string_index = string_index + 2;
end
der_index = 2;
if sum(system.struct.der(2:end,der_index)) >= 1
    string_handles{string_index}=strrep(string_handles{string_index},'[]','@hessians');
    string_handles{string_index+1}=strrep(string_handles{string_index+1},'[]','@hessiansp');
    string_index = string_index + 2;    
end
for der_index = 3:5
    if sum(system.struct.der(2:end,der_index)) >= 1
            string_handles{string_index} = strrep(string_handles{string_index},'[]', sprintf('@der%i', der_index));    
    end
    string_index = string_index + 1;   
end
            

                
if ~isempty(system.struct.uf.UserfunctionsInfo)
    siz = size(system.struct.uf.UserfunctionsInfo,2);
    for i = 1:siz
        string_handles{9+i,1}= sprintf('out{%d}= @%s;',9+i,system.struct.uf.UserfunctionsInfo(i).name);
    end
else siz=0;end



fprintf(fid_write, strrep(fgetl(fid_read),'odefile',system.struct.system));
fprintf(fid_write, '\n');

for i=1:9+siz
    fprintf(fid_write,'%s\n',string_handles{i,1});
end
fprintf(fid_write, '%s', system.struct.filecontent);


if ~isempty(system.struct.uf.UserfunctionsInfo)    
   for i=1:size(system.struct.uf.UserfunctionsInfo,2)
       res=0;
       if isfield(system.struct,'userfunction') && ~isempty(system.struct.userfunction{i})
           str_user = systems('replace_token',cellstr(system.struct.userfunction{i}));
       else 
           str_user=cellstr('res=');
       end

       [~,~,newpar] = renameforsym('', '', strip(par, ','));
       newpar = strcat(',', newpar);
       hs1 = sprintf('function userfun%d=%s(t,kmrgd%s)',i,system.struct.uf.UserfunctionsInfo(i).name,newpar);
       fprintf(fid_write,'%s\n',hs1);
       hs1 = sprintf('userfun%d',i);
       dim = size(str_user,1);
       for j = 1:dim
           userline = renameforsym(str_user{j}, '', strip(par, ','));
           d = strmatch('res=',userline,'exact');
           if findstr('res',userline),res=1;end
           userline = strrep(userline,'res',hs1);
           if d==1
               fprintf(fid_write,'\t%s=0;\n',hs1);
           else 
               fprintf(fid_write,'\t%s;\n',userline);
           end
       end
       if res==0,fprintf(fid_write,'\t%s=0;\n',hs1);end
   end
end        


fclose(fid_read);
fclose(fid_write);

delete(handles.userfunfig);


rehash;

