function [nq,q_scaled] = vecscale(q)
%----------------------------------------------------
% Scaling the vectors to unit vectors if necessary.
% Store norm to scale final result. For finite
% directional differences the result may otherwise be
% inaccurate, but if norm(q)=0 or small, we can use q itself.
%----------------------------------------------------
if (norm(q)>1)
    nq=norm(q);
    q_scaled=q/nq;
else
    nq=1;
    q_scaled=q;
end
